std::basic_istream< _CharT, _Traits > Class Template Reference
I/O

`#include <istream>`

Inheritance diagram for std::basic_istream< _CharT, _Traits >:
[legend]

## Classes

class | sentry

## Public Types

typedef ctype< _CharT > | __ctype_type
typedef basic_ios< _CharT, _Traits > | __ios_type
typedef basic_istream< _CharT, _Traits > | __istream_type
typedef num_get< _CharT, istreambuf_iterator< _CharT, _Traits > > | __num_get_type
typedef basic_streambuf< _CharT, _Traits > | __streambuf_type
typedef _CharT | char_type
enum | event { erase_event , imbue_event , copyfmt_event }
typedef void(* | event_callback) (event __e, ios_base &__b, int __i)
typedef _Traits::int_type | int_type
typedef _Ios_Iostate | iostate
typedef _Traits::off_type | off_type
typedef _Ios_Openmode | openmode
typedef _Traits::pos_type | pos_type
typedef _Ios_Seekdir | seekdir
typedef _Traits | traits_type
typedef num_put< _CharT, ostreambuf_iterator< _CharT, _Traits > > | __num_put_type

## Public Member Functions

| basic_istream (__streambuf_type *__sb)
virtual | ~basic_istream ()
template<typename _ValueT>
basic_istream< _CharT, _Traits > & | _M_extract (_ValueT &__v)
const locale & | _M_getloc () const
void | _M_setstate (iostate __state)
bool | bad () const
void | clear (iostate __state=goodbit)
basic_ios & | copyfmt (const basic_ios &__rhs)
bool | eof () const
iostate | exceptions () const
void | exceptions (iostate __except)
bool | fail () const
char_type | fill () const
char_type | fill (char_type __ch)
fmtflags | flags () const
fmtflags | flags (fmtflags __fmtfl)
streamsize | gcount () const
basic_istream< wchar_t > & | getline (char_type *__s, streamsize __n, char_type __delim)
basic_istream< char > & | getline (char_type *__s, streamsize __n, char_type __delim)
locale | getloc () const
bool | good () const
basic_istream< wchar_t > & | ignore (streamsize __n)
basic_istream< char > & | ignore (streamsize __n)
basic_istream< wchar_t > & | ignore (streamsize __n, int_type __delim)
basic_istream< char > & | ignore (streamsize __n, int_type __delim)
locale | imbue (const locale &__loc)
long & | iword (int __ix)
char | narrow (char_type __c, char __dfault) const
__istream_type & | operator>> (__streambuf_type *__sb)
__istream_type & | operator>> (void *&__p)
streamsize | precision () const
streamsize | precision (streamsize __prec)
void *& | pword (int __ix)
basic_streambuf< _CharT, _Traits > * | rdbuf () const
basic_streambuf< _CharT, _Traits > * | rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
iostate | rdstate () const
void | register_callback (event_callback __fn, int __index)
fmtflags | setf (fmtflags __fmtfl)
fmtflags | setf (fmtflags __fmtfl, fmtflags __mask)
void | setstate (iostate __state)
basic_ostream< _CharT, _Traits > * | tie () const
basic_ostream< _CharT, _Traits > * | tie (basic_ostream< _CharT, _Traits > *__tiestr)
void | unsetf (fmtflags __mask)
char_type | widen (char __c) const
streamsize | width () const
streamsize | width (streamsize __wide)
__istream_type & | operator>> (__istream_type &(*__pf)(__istream_type &))
__istream_type & | operator>> (__ios_type &(*__pf)(__ios_type &))
__istream_type & | operator>> (ios_base &(*__pf)(ios_base &))
Extractors

All the `operator>>` functions (aka formatted input functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to false. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state (without causing an ios_base::failure to be thrown) and the original exception will be rethrown if badbit is set in the exceptions mask.

__istream_type & | operator>> (bool &__n)
__istream_type & | operator>> (short &__n)
__istream_type & | operator>> (unsigned short &__n)
__istream_type & | operator>> (int &__n)
__istream_type & | operator>> (unsigned int &__n)
__istream_type & | operator>> (long &__n)
__istream_type & | operator>> (unsigned long &__n)
__istream_type & | operator>> (long long &__n)
__istream_type & | operator>> (unsigned long long &__n)
__istream_type & | operator>> (float &__f)
__istream_type & | operator>> (double &__f)
__istream_type & | operator>> (long double &__f)
Unformatted Input Functions

All the unformatted input functions have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to true. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

The number of characters extracted is stored for later retrieval by gcount().

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state (without causing an ios_base::failure to be thrown) and the original exception will be rethrown if badbit is set in the exceptions mask.

int_type | get ()
__istream_type & | get (char_type &__c)
__istream_type & | get (char_type *__s, streamsize __n, char_type __delim)
__istream_type & | get (char_type *__s, streamsize __n)
__istream_type & | get (__streambuf_type &__sb, char_type __delim)
__istream_type & | get (__streambuf_type &__sb)
__istream_type & | getline (char_type *__s, streamsize __n, char_type __delim)
__istream_type & | getline (char_type *__s, streamsize __n)
__istream_type & | ignore (streamsize __n, int_type __delim)
__istream_type & | ignore (streamsize __n)
__istream_type & | ignore ()
int_type | peek ()
__istream_type & | read (char_type *__s, streamsize __n)
streamsize | readsome (char_type *__s, streamsize __n)
__istream_type & | putback (char_type __c)
__istream_type & | unget ()
int | sync ()
pos_type | tellg ()
__istream_type & | seekg (pos_type)
__istream_type & | seekg (off_type, ios_base::seekdir)
| operator bool () const
bool | operator! () const

## Static Public Member Functions

static bool | sync_with_stdio (bool __sync=true)
static int | xalloc () throw ()

## Public Attributes

class __attribute((__abi_tag__("cxx11"))) failure typedef _Ios_Fmtflags | fmtflags

## Static Public Attributes

static const openmode | __noreplace
static const fmtflags | adjustfield
static const openmode | app
static const openmode | ate
static const iostate | badbit
static const fmtflags | basefield
static const seekdir | beg
static const openmode | binary
static const fmtflags | boolalpha
static const seekdir | cur
static const fmtflags | dec
static const seekdir | end
static const iostate | eofbit
static const iostate | failbit
static const fmtflags | fixed
static const fmtflags | floatfield
static const iostate | goodbit
static const fmtflags | hex
static const openmode | in
static const fmtflags | internal
static const fmtflags | left
static const fmtflags | oct
static const openmode | out
static const fmtflags | right
static const fmtflags | scientific
static const fmtflags | showbase
static const fmtflags | showpoint
static const fmtflags | showpos
static const fmtflags | skipws
static const openmode | trunc
static const fmtflags | unitbuf
static const fmtflags | uppercase

## Protected Types

enum | { _S_local_word_size }

## Protected Member Functions

| basic_istream (basic_istream &&__rhs)
| basic_istream (const basic_istream &)=delete
void | _M_cache_locale (const locale &__loc)
void | _M_call_callbacks (event __ev) throw ()
void | _M_dispose_callbacks (void) throw ()
template<typename _ValueT>
__istream_type & | _M_extract (_ValueT &__v)
_Words & | _M_grow_words (int __index, bool __iword)
void | _M_init () throw ()
void | _M_move (ios_base &) noexcept
void | _M_swap (ios_base &__rhs) noexcept
void | init (basic_streambuf< _CharT, _Traits > *__sb)
void | move (basic_ios &&__rhs)
void | move (basic_ios &__rhs)
basic_istream & | operator= (basic_istream &&__rhs)
basic_istream & | operator= (const basic_istream &)=delete
void | set_rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
void | swap (basic_ios &__rhs) noexcept
void | swap (basic_istream &__rhs)

## Protected Attributes

_Callback_list * | _M_callbacks
const __ctype_type * | _M_ctype
iostate | _M_exception
char_type | _M_fill
bool | _M_fill_init
fmtflags | _M_flags
streamsize | _M_gcount
locale | _M_ios_locale
_Words | _M_local_word [_S_local_word_size]
const __num_get_type * | _M_num_get
const __num_put_type * | _M_num_put
streamsize | _M_precision
basic_streambuf< _CharT, _Traits > * | _M_streambuf
iostate | _M_streambuf_state
basic_ostream< _CharT, _Traits > * | _M_tie
streamsize | _M_width
_Words * | _M_word
int | _M_word_size
_Words | _M_word_zero

## Friends

class | sentry

## Detailed Description

template<typename _CharT, typename _Traits>
class std::basic_istream< _CharT, _Traits >

Template class basic_istream.

Template Parameters

  _CharT | Type of character stream.
  _Traits | Traits for character type, defaults to char_traits<_CharT>.

This is the base class for all input streams. It provides text formatting of all builtin types, and communicates with any class derived from basic_streambuf to do the actual input.

Definition at line 60 of file istream.

## Member Typedef Documentation

## __ctype_type

template<typename _CharT, typename _Traits>

typedef ctype<_CharT> std::basic_istream< _CharT, _Traits >::__ctype_type

Definition at line 76 of file istream.

## __ios_type

template<typename _CharT, typename _Traits>

typedef basic_ios<_CharT, _Traits> std::basic_istream< _CharT, _Traits >::__ios_type

Definition at line 72 of file istream.

## __istream_type

template<typename _CharT, typename _Traits>

typedef basic_istream<_CharT, _Traits> std::basic_istream< _CharT, _Traits >::__istream_type

Definition at line 73 of file istream.

## __num_get_type

template<typename _CharT, typename _Traits>

typedef num_get<_CharT, istreambuf_iterator<_CharT, _Traits> > std::basic_istream< _CharT, _Traits >::__num_get_type

Definition at line 75 of file istream.

## __num_put_type

template<typename _CharT, typename _Traits>

typedef num_put<_CharT, ostreambuf_iterator<_CharT, _Traits> > std::basic_ios< _CharT, _Traits >::__num_put_type

inherited

These are non-standard types.

Definition at line 89 of file basic_ios.h.

## __streambuf_type

template<typename _CharT, typename _Traits>

typedef basic_streambuf<_CharT, _Traits> std::basic_istream< _CharT, _Traits >::__streambuf_type

Definition at line 71 of file istream.

## char_type

template<typename _CharT, typename _Traits>

typedef _CharT std::basic_istream< _CharT, _Traits >::char_type

Definition at line 64 of file istream.

## event_callback

typedef void(* std::ios_base::event_callback) (event __e, ios_base &__b, int __i)

inherited

The type of an event callback function.

Parameters

  __e | One of the members of the event enum.
  __b | Reference to the ios_base object.
  __i | The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 542 of file ios_base.h.

## int_type

template<typename _CharT, typename _Traits>

typedef _Traits::int_type std::basic_istream< _CharT, _Traits >::int_type

Definition at line 65 of file istream.

## iostate

typedef _Ios_Iostate std::ios_base::iostate

inherited

This is a bitmask type.

`_Ios_Iostate is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 421 of file ios_base.h.

## off_type

template<typename _CharT, typename _Traits>

typedef _Traits::off_type std::basic_istream< _CharT, _Traits >::off_type

Definition at line 67 of file istream.

## openmode

typedef _Ios_Openmode std::ios_base::openmode

inherited

This is a bitmask type.

`_Ios_Openmode is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 452 of file ios_base.h.

## pos_type

template<typename _CharT, typename _Traits>

typedef _Traits::pos_type std::basic_istream< _CharT, _Traits >::pos_type

Definition at line 66 of file istream.

## seekdir

typedef _Ios_Seekdir std::ios_base::seekdir

inherited

This is an enumerated type.

`_Ios_Seekdir is` implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEK_CUR` in the C standard library.
- end, equivalent to `SEEK_END` in the C standard library.

Definition at line 492 of file ios_base.h.

## traits_type

template<typename _CharT, typename _Traits>

typedef _Traits std::basic_istream< _CharT, _Traits >::traits_type

Definition at line 68 of file istream.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

protected inherited

Definition at line 617 of file ios_base.h.

## event

enum std::ios_base::event

inherited

The set of events that may be passed to an event callback.

erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 525 of file ios_base.h.

## Constructor & Destructor Documentation

## basic_istream() [1/3]

template<typename _CharT, typename _Traits>

std::basic_istream< _CharT, _Traits >::basic_istream | ( | __streambuf_type * | __sb | ) |

inline explicit

Base constructor.

This ctor is almost never called by the user directly, rather from derived classes' initialization lists, which pass a pointer to their own stream buffer.

Definition at line 95 of file istream.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry().

## ~basic_istream()

template<typename _CharT, typename _Traits>

virtual std::basic_istream< _CharT, _Traits >::~basic_istream | ( |  | ) |

inline virtual

Base destructor.

This does very little apart from providing a virtual base dtor.

Definition at line 105 of file istream.

## basic_istream() [2/3]

template<typename _CharT, typename _Traits>

std::basic_istream< _CharT, _Traits >::basic_istream | ( |  | ) |

inline protected

Definition at line 696 of file istream.

## basic_istream() [3/3]

template<typename _CharT, typename _Traits>

std::basic_istream< _CharT, _Traits >::basic_istream | ( | basic_istream< _CharT, _Traits > && | __rhs | ) |

inline protected

Definition at line 703 of file istream.

## Member Function Documentation

## _M_cache_locale()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::_M_cache_locale | ( | const locale & | __loc | ) |

protected inherited

Definition at line 157 of file basic_ios.tcc.

## _M_extract()

template<typename _CharT, typename _Traits>
template<typename _ValueT>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::_M_extract | ( | _ValueT & | __v | ) |

Definition at line 96 of file istream.tcc.

## _M_getloc()

const locale & std::ios_base::_M_getloc | ( |  | ) | const

inline inherited

Locale access.

Returns
  A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 817 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::num_put< _CharT, _OutIter >::do_put(), std::time_put< _CharT, _OutIter >::do_put(), std::time_get< _CharT, _InIter >::get(), and std::time_put< _CharT, _OutIter >::put().

## _M_setstate()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::_M_setstate | ( | iostate | __state | ) |

inline inherited

Definition at line 164 of file basic_ios.h.

## bad()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::bad | ( |  | ) | const

inline inherited

Fast error checking.

Returns
  True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 211 of file basic_ios.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry().

## clear()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::clear | ( | iostate | __state = goodbit | ) |

inherited

[Re]sets the error state.

Parameters

  __state | The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 41 of file basic_ios.tcc.

References std::ios_base::badbit, exceptions(), rdbuf(), and rdstate().

Referenced by std::basic_ios< char_type, traits_type >::exceptions(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::__detail::operator>>(), std::basic_istream< _CharT, _Traits >::putback(), rdbuf(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ios< char_type, traits_type >::setstate(), and std::basic_istream< _CharT, _Traits >::unget().

## copyfmt()

template<typename _CharT, typename _Traits>

basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt | ( | const basic_ios< _CharT, _Traits > & | __rhs | ) |

inherited

Copies fields of __rhs into this.

Parameters

  __rhs | The source values for the copies.

Returns
  Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

Definition at line 63 of file basic_ios.tcc.

References basic_ios(), std::__addressof(), exceptions(), fill(), std::ios_base::flags(), std::ios_base::getloc(), std::ios_base::precision(), tie(), std::tie(), and std::ios_base::width().

## eof()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::eof | ( |  | ) | const

inline inherited

Fast error checking.

Returns
  True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 190 of file basic_ios.h.

## exceptions() [1/2]

template<typename _CharT, typename _Traits>

iostate std::basic_ios< _CharT, _Traits >::exceptions | ( |  | ) | const

inline inherited

Throwing exceptions on errors.

Returns
  The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 222 of file basic_ios.h.

Referenced by clear(), and copyfmt().

## exceptions() [2/2]

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::exceptions | ( | iostate | __except | ) |

inline inherited

Throwing exceptions on errors.

Parameters

  __except | The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flag is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

#include <iostream>
#include <fstream>
#include <exception>
int main()
{
std::set_terminate (__gnu_cxx::__verbose_terminate_handler);
std::ifstream f ("/etc/motd");
std::cerr << "Setting badbit\n";
f.setstate (std::ios_base::badbit);
std::cerr << "Setting exception mask\n";
f.exceptions (std::ios_base::badbit);
}
exception
fstream
iostream
std::ifstream
basic_ifstream< char > ifstream
Class for char input file streams.
Definition iosfwd:164
std::set_terminate
terminate_handler set_terminate(terminate_handler) noexcept
Takes a new handler function as an argument, returns the old function.
__gnu_cxx::__verbose_terminate_handler
void __verbose_terminate_handler()
A replacement for the standard terminate_handler which prints more information about the terminating ...
std::cerr
ostream cerr
Linked to standard error (unbuffered).
std::ios_base::badbit
static const iostate badbit
Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error fro...
Definition ios_base.h:425

Definition at line 257 of file basic_ios.h.

## fail()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::fail | ( |  | ) | const

inline inherited

Fast error checking.

Returns
  True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 201 of file basic_ios.h.

Referenced by std::basic_ios< char_type, traits_type >::operator bool(), std::basic_ios< char_type, traits_type >::operator!(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::regex_traits< _Ch_type >::value().

## fill() [1/2]

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::fill | ( |  | ) | const

inline inherited

Retrieves the empty character.

Returns
  The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 370 of file basic_ios.h.

Referenced by copyfmt(), and std::basic_ios< char_type, traits_type >::fill().

## fill() [2/2]

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::fill | ( | char_type | __ch | ) |

inline inherited

Sets a new empty character.

Parameters

  __ch | The new character.

Returns
  The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 390 of file basic_ios.h.

## flags() [1/2]

fmtflags std::ios_base::flags | ( |  | ) | const

inline inherited

Access to format flags.

Returns
  The format control flags for both input and output.

Definition at line 662 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::num_put< _CharT, _OutIter >::do_put(), std::chrono::operator<<(), std::operator<<(), std::__detail::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), and std::operator>>().

## flags() [2/2]

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) |

inline inherited

Setting new format flags all at once.

Parameters

  __fmtfl | The new flags to set.

Returns
  The previous format control flags.

This function overwrites all the format flags with __fmtfl.

Definition at line 673 of file ios_base.h.

References fmtflags.

## gcount()

template<typename _CharT, typename _Traits>

streamsize std::basic_istream< _CharT, _Traits >::gcount | ( |  | ) | const

inline

Character counting.

Returns
  The number of characters extracted by the previous unformatted input function dispatched for this stream.

Definition at line 359 of file istream.

## get() [1/6]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::get | ( | void |  | ) |

Simple extraction.

Returns
  A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 260 of file istream.tcc.

References _M_gcount, std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

Referenced by std::basic_istream< char_type, traits_type >::get(), and std::basic_istream< char_type, traits_type >::get().

## get() [2/6]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb | ) |

inline

Extraction into another streambuf.

Parameters

  __sb | A streambuf in which to store data.

Returns
  *this

Returns `get`(__sb,widen('\n')).

Definition at line 477 of file istream.

## get() [3/6]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb,
|  | char_type | __delim )

Extraction into another streambuf.

Parameters

  __sb | A streambuf in which to store data.
  __delim | A "stop" character.

Returns
  *this

Characters are extracted and inserted into __sb until one of the following happens:

- the input sequence reaches EOF
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted)
- the next character equals __delim (in this case, the character is not extracted)
- an exception occurs (and in this case is caught)

If no characters are stored, failbit is set in the stream's error state.

Definition at line 380 of file istream.tcc.

References _M_gcount, and std::ios_base::goodbit.

## get() [4/6]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type & | __c | ) |

Simple extraction.

Parameters

  __c | The character in which to store data.

Returns
  *this

Tries to extract a character and store it in __c. If none are available, sets failbit and returns traits::eof().

Note
  This function is not overloaded on signed char and unsigned char.

Definition at line 296 of file istream.tcc.

References _M_gcount, std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

## get() [5/6]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n )

inline

Simple multiple-character extraction.

Parameters

  __s | Pointer to an array.
  __n | Maximum number of characters to store in s.

Returns
  *this

Returns `get`(__s,__n,widen('\n')).

Definition at line 444 of file istream.

## get() [6/6]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim )

Simple multiple-character extraction.

Parameters

  __s | Pointer to an array.
  __n | Maximum number of characters to store in __s.
  __delim | A "stop" character.

Returns
  *this

Characters are extracted and stored into __s until one of the following happens:

- `__n-1` characters are stored
- the input sequence reaches EOF
- the next character equals __delim, in which case the character is not extracted

If no characters are stored, failbit is set in the stream's error state.

In any case, a null character is stored into the next location in the array.

Note
  This function is not overloaded on signed char and unsigned char.

Definition at line 333 of file istream.tcc.

References _M_gcount, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_streambuf< _CharT, _Traits >::sgetc().

## getline() [1/3]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n )

inline

String extraction.

Parameters

  __s | A character array in which to store the data.
  __n | Maximum number of characters to extract.

Returns
  *this

Returns `getline`(__s,__n,widen('\n')).

Definition at line 517 of file istream.

## getline() [2/3]

basic_istream< char > & std::basic_istream< char >::getline | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim )

Explicit specialization declarations, defined in src/istream.cc.

## getline() [3/3]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim )

String extraction.

Parameters

  __s | A character array in which to store the data.
  __n | Maximum number of characters to extract.
  __delim | A "stop" character.

Returns
  *this

Extracts and stores characters into __s until one of the following happens. Note that these criteria are required to be tested in the order listed here, to allow an input line to exactly fill the __s array without setting failbit.

1. the input sequence reaches end-of-file, in which case eofbit is set in the stream error state
2. the next character equals `__delim`, in which case the character is extracted (and therefore counted in `gcount()`) but not stored
3. `__n-1` characters are stored, in which case failbit is set in the stream error state

If no characters are extracted, failbit is set. (An empty line of input should therefore not cause failbit to be set.)

In any case, a null character is stored in the next location in the array.

Definition at line 431 of file istream.tcc.

Referenced by std::basic_istream< char_type, traits_type >::getline().

## getloc()

locale std::ios_base::getloc | ( |  | ) | const

inline inherited

Locale access.

Returns
  A copy of the current locale.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 806 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::money_put< _CharT, _OutIter >::do_put(), std::basic_ios< _CharT, _Traits >::imbue(), std::chrono::operator<<(), std::operator>>(), std::operator>>(), and std::ws().

## good()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::good | ( |  | ) | const

inline inherited

Fast error checking.

Returns
  True if no error flags are set.

A wrapper around rdstate.

Definition at line 180 of file basic_ios.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_ostream< _CharT, _Traits >::sentry::sentry(), and std::__detail::operator>>().

## ignore() [1/3]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( | void |  | ) |

Simple extraction.

Returns
  A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 491 of file istream.tcc.

References _M_gcount, std::ios_base::eofbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_streambuf< _CharT, _Traits >::sbumpc().

## ignore() [2/3]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( | streamsize | __n | ) |

Simple extraction.

Returns
  A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 524 of file istream.tcc.

References _M_gcount, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_streambuf< _CharT, _Traits >::sgetc().

## ignore() [3/3]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( | streamsize | __n,
|  | int_type | __delim )

Discarding characters.

Parameters

  __n | Number of characters to discard.
  __delim | A "stop" character.

Returns
  *this

Extracts characters and throws them away until one of the following happens:

- if __n `!=` `std::numeric_limits<int>::max()`, __n characters are extracted
- the input sequence reaches end-of-file
- the next character equals __delim (in this case, the character is extracted); note that this condition will never occur if __delim equals `traits::eof()`.

NB: Provide three overloads, instead of the single function (with defaults) mandated by the Standard: this leads to a better performing implementation, while still conforming to the Standard.

Definition at line 594 of file istream.tcc.

## imbue()

template<typename _CharT, typename _Traits>

locale std::basic_ios< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) |

inherited

Moves to a new locale.

Parameters

  __loc | The new locale.

Returns
  The previous locale.

Calls `ios_base::imbue(loc)`, and if a stream buffer is associated with this stream, calls that buffer's `pubimbue(loc)`.

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 114 of file basic_ios.tcc.

References std::ios_base::getloc(), std::ios_base::imbue(), and rdbuf().

Referenced by std::chrono::operator<<().

## init()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::init | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |

protected inherited

All setup is performed here.

This is called from the public constructor. It is not virtual and cannot be redefined.

Definition at line 126 of file basic_ios.tcc.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ios< char_type, traits_type >::basic_ios(), std::basic_istream< char_type, traits_type >::basic_istream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ostream< char_type, traits_type >::basic_ostream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_stringstream< char >::basic_stringstream(), std::basic_stringstream< char >::basic_stringstream(), and std::basic_stringstream< char >::basic_stringstream().

## iword()

long & std::ios_base::iword | ( | int | __ix | ) |

inline inherited

Access to integer array.

Parameters

  __ix | Index into the array.

Returns
  A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 852 of file ios_base.h.

References iword().

Referenced by iword().

## move() [1/2]

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::move | ( | basic_ios< _CharT, _Traits > && | __rhs | ) |

inline protected inherited

Definition at line 490 of file basic_ios.h.

## move() [2/2]

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::move | ( | basic_ios< _CharT, _Traits > & | __rhs | ) |

inline protected inherited

Definition at line 479 of file basic_ios.h.

## narrow()

template<typename _CharT, typename _Traits>

char std::basic_ios< _CharT, _Traits >::narrow | ( | char_type | __c,
|  | char | __dfault ) const

inline inherited

Squeezes characters.

Parameters

  __c | The character to narrow.
  __dfault | The character to narrow.

Returns
  The narrowed character.

Maps a character of `char_type` to a character of `char`, if possible.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)
std::use_facet
const _Facet & use_facet(const locale &__loc)
Return a facet.
Definition locale_classes.tcc:192
std::basic_ios::narrow
char narrow(char_type __c, char __dfault) const
Squeezes characters.
Definition basic_ios.h:430
std::ios_base::getloc
locale getloc() const
Locale access.
Definition ios_base.h:806

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 430 of file basic_ios.h.

## operator bool()

template<typename _CharT, typename _Traits>

std::basic_ios< _CharT, _Traits >::operator bool | ( |  | ) | const

inline explicit inherited

The quick-and-easy status check.

This allows you to write constructs such as `if (!a_stream) ...` and `while (a_stream) ...`

Definition at line 117 of file basic_ios.h.

## operator!()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::operator! | ( |  | ) | const

inline inherited

The quick-and-easy status check.

This allows you to write constructs such as `if (!a_stream) ...` and `while (a_stream) ...`

Definition at line 125 of file basic_ios.h.

## operator=()

template<typename _CharT, typename _Traits>

basic_istream & std::basic_istream< _CharT, _Traits >::operator= | ( | basic_istream< _CharT, _Traits > && | __rhs | ) |

inline protected

Definition at line 715 of file istream.

## operator>>() [1/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | __ios_type &(* | __pf )(__ios_type &) | ) |

inline

Interface for manipulators.

Manipulators such as `std::ws` and `std::dec` use these functions in constructs like `std::cin >> std::ws`. For more information, see the iomanip header.

Definition at line 126 of file istream.

## operator>>() [2/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | __istream_type &(* | __pf )(__istream_type &) | ) |

inline

Interface for manipulators.

Manipulators such as `std::ws` and `std::dec` use these functions in constructs like `std::cin >> std::ws`. For more information, see the iomanip header.

Definition at line 122 of file istream.

## operator>>() [3/17]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __streambuf_type * | __sb | ) |

Extracting into another streambuf.

Parameters

  __sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If `__sb` is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the `__sb` streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 228 of file istream.tcc.

References std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

## operator>>() [4/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | bool & | __n | ) |

inline

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 170 of file istream.

## operator>>() [5/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | double & | __f | ) |

inline

Floating point arithmetic extractors.

Parameters

  __f | A variable of builtin floating point type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 220 of file istream.

## operator>>() [6/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | float & | __f | ) |

inline

Floating point arithmetic extractors.

Parameters

  __f | A variable of builtin floating point type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 216 of file istream.

## operator>>() [7/17]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | int & | __n | ) |

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 178 of file istream.tcc.

## operator>>() [8/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | ios_base &(* | __pf )(ios_base &) | ) |

inline

Interface for manipulators.

Manipulators such as `std::ws` and `std::dec` use these functions in constructs like `std::cin >> std::ws`. For more information, see the iomanip header.

Definition at line 133 of file istream.

## operator>>() [9/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | long & | __n | ) |

inline

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 188 of file istream.

## operator>>() [10/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | long double & | __f | ) |

inline

Floating point arithmetic extractors.

Parameters

  __f | A variable of builtin floating point type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 224 of file istream.

## operator>>() [11/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | long long & | __n | ) |

inline

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 197 of file istream.

## operator>>() [12/17]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | short & | __n | ) |

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 128 of file istream.tcc.

References std::ios_base::badbit, std::ios_base::failbit, std::num_get< _CharT, _InIter >::get(), std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::setstate(), and std::use_facet().

## operator>>() [13/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned int & | __n | ) |

inline

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 184 of file istream.

## operator>>() [14/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long & | __n | ) |

inline

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 192 of file istream.

## operator>>() [15/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long long & | __n | ) |

inline

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 201 of file istream.

## operator>>() [16/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned short & | __n | ) |

inline

Integer arithmetic extractors.

Parameters

  __n | A variable of builtin integral type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 177 of file istream.

## operator>>() [17/17]

template<typename _CharT, typename _Traits>

__istream_type & std::basic_istream< _CharT, _Traits >::operator>> | ( | void *& | __p | ) |

inline

Basic arithmetic extractors.

Parameters

  __p | A variable of pointer type.

Returns
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 325 of file istream.

## peek()

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::peek | ( | void |  | ) |

Looking ahead in the stream.

Returns
  The next character, or eof().

If, after constructing the sentry object, `good()` is false, returns `traits::eof()`. Otherwise reads but does not extract the next input character.

Definition at line 671 of file istream.tcc.

References _M_gcount.

## precision() [1/2]

streamsize std::ios_base::precision | ( |  | ) | const

inline inherited

Flags access.

Returns
  The precision to generate on certain output operations.

Be careful if you try to give a definition of precision here; see DR 189.

Definition at line 732 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), and std::chrono::operator<<().

## precision() [2/2]

streamsize std::ios_base::precision | ( | streamsize | __prec | ) |

inline inherited

Changing flags.

Parameters

  __prec | The new precision value.

Returns
  The previous value of precision().

Definition at line 741 of file ios_base.h.

## putback()

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::putback | ( | char_type | __c | ) |

Unextracting a single character.

Parameters

  __c | The character to push back into the input stream.

Returns
  *this

If `rdbuf()` is not null, calls `rdbuf()->sputbackc(c)`.

If `rdbuf()` is null or if `sputbackc()` fails, sets badbit in the error state.

Note
  This function first clears eofbit. Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 762 of file istream.tcc.

References _M_gcount, std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::rdstate(), std::basic_ios< _CharT, _Traits >::setstate(), and std::basic_streambuf< _CharT, _Traits >::sputbackc().

Referenced by std::operator<<().

## pword()

void *& std::ios_base::pword | ( | int | __ix | ) |

inline inherited

Access to void pointer array.

Parameters

  __ix | Index into the array.

Returns
  A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 873 of file ios_base.h.

## rdbuf() [1/2]

template<typename _CharT, typename _Traits>

basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf | ( |  | ) | const

inline inherited

Accessing the underlying buffer.

Returns
  The current stream buffer.

This does not change the state of the stream.

Definition at line 321 of file basic_ios.h.

Referenced by clear(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), imbue(), std::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::tr2::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::ws().

## rdbuf() [2/2]

template<typename _CharT, typename _Traits>

basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |

inherited

Changing the underlying buffer.

Parameters

  __sb | The new stream buffer.

Returns
  The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument `rdbuf()`, which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

std::fstream foo; // or some other derived type
std::streambuf* p = .....;
foo.ios::rdbuf(p); // ios == basic_ios<char>
std::streambuf
basic_streambuf< char > streambuf
Base class for char buffers.
Definition iosfwd:137
std::fstream
basic_fstream< char > fstream
Class for char mixed input and output file streams.
Definition iosfwd:170

Definition at line 53 of file basic_ios.tcc.

References clear().

## rdstate()

template<typename _CharT, typename _Traits>

iostate std::basic_ios< _CharT, _Traits >::rdstate | ( |  | ) | const

inline inherited

Returns the error state of the stream buffer.

Returns
  A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 137 of file basic_ios.h.

Referenced by std::basic_ios< char_type, traits_type >::bad(), clear(), std::basic_ios< char_type, traits_type >::eof(), std::basic_ios< char_type, traits_type >::fail(), std::basic_ios< char_type, traits_type >::good(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ios< char_type, traits_type >::setstate(), and std::basic_istream< _CharT, _Traits >::unget().

## read()

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::read | ( | char_type * | __s,
|  | streamsize | __n )

Extraction without delimiters.

Parameters

  __s | A character array.
  __n | Maximum number of characters to store.

Returns
  *this

If the stream state is `good()`, extracts characters and stores them into __s until one of the following happens:

- __n characters are stored
- the input sequence reaches end-of-file, in which case the error state is set to `failbit|eofbit`.

Note
  This function is not overloaded on signed char and unsigned char.

Definition at line 701 of file istream.tcc.

References _M_gcount, std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

## readsome()

template<typename _CharT, typename _Traits>

streamsize std::basic_istream< _CharT, _Traits >::readsome | ( | char_type * | __s,
|  | streamsize | __n )

Extraction until the buffer is exhausted, but no more.

Parameters

  __s | A character array.
  __n | Maximum number of characters to store.

Returns
  The number of characters extracted.

Extracts characters and stores them into __s depending on the number of characters remaining in the streambuf's buffer, `rdbuf()->in_avail()`, called `A` here:

- if `A` `==` `-1`, sets eofbit and extracts no characters
- if `A` `==` `0`, extracts no characters
- if `A` `>` `0`, extracts `min(A,n)`

The goal is to empty the current buffer, and to not request any more from the external input sequence controlled by the streambuf.

Definition at line 730 of file istream.tcc.

References _M_gcount, std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, std::min(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

## register_callback()

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | __index )

inherited

Add the callback __fn with parameter __index.

Parameters

  __fn | The function to add.
  __index | The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

References fmtflags.

## seekg() [1/2]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | off_type | __off,
|  | ios_base::seekdir | __dir )

Changing the current read position.

Parameters

  __off | A file offset object.
  __dir | The direction in which to seek.

Returns
  *this

If `fail()` is not true, calls `rdbuf()->pubseekoff(__off,__dir)`. If that function fails, sets failbit.

Note
  This function first clears eofbit. It does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 935 of file istream.tcc.

References std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::in, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::rdstate(), and std::basic_ios< _CharT, _Traits >::setstate().

## seekg() [2/2]

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | pos_type | __pos | ) |

Changing the current read position.

Parameters

  __pos | A file position object.

Returns
  *this

If `fail()` is not true, calls `rdbuf()->pubseekpos(__pos)`. If that function fails, sets failbit.

Note
  This function first clears eofbit. It does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 896 of file istream.tcc.

References std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::in, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::rdstate(), and std::basic_ios< _CharT, _Traits >::setstate().

## set_rdbuf()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::set_rdbuf | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |

inline protected inherited

Definition at line 505 of file basic_ios.h.

## setf() [1/2]

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) |

inline inherited

Setting new format flags.

Parameters

  __fmtfl | Additional flags to set.

Returns
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 689 of file ios_base.h.

References fmtflags.

Referenced by std::__detail::operator>>().

## setf() [2/2]

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask )

inline inherited

Setting new format flags.

Parameters

  __fmtfl | Additional flags to set.
  __mask | The flags mask for fmtfl.

Returns
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 706 of file ios_base.h.

References fmtflags.

## setstate()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::setstate | ( | iostate | __state | ) |

inline inherited

Sets additional flags in the error state.

Parameters

  __state | The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 157 of file basic_ios.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry(), std::basic_fstream< char >::close(), std::basic_ifstream< char >::close(), std::basic_ofstream< char >::close(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::getline(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::operator<<(), std::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::tr2::operator>>(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), and std::ws().

## swap() [1/2]

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::swap | ( | basic_ios< _CharT, _Traits > & | __rhs | ) |

inline protected noexcept inherited

Definition at line 494 of file basic_ios.h.

## swap() [2/2]

template<typename _CharT, typename _Traits>

void std::basic_istream< _CharT, _Traits >::swap | ( | basic_istream< _CharT, _Traits > & | __rhs | ) |

inline protected

Definition at line 722 of file istream.

## sync()

template<typename _CharT, typename _Traits>

int std::basic_istream< _CharT, _Traits >::sync | ( | void |  | ) |

Synchronizing the stream buffer.

Returns
  0 on success, -1 on failure

If `rdbuf()` is a null pointer, returns -1.

Otherwise, calls `rdbuf()->pubsync()`, and if that returns -1, sets badbit and returns -1.

Otherwise, returns 0.

Note
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 832 of file istream.tcc.

References std::ios_base::badbit, std::ios_base::goodbit, std::basic_streambuf< _CharT, _Traits >::pubsync(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

## sync_with_stdio()

bool std::ios_base::sync_with_stdio | ( | bool | __sync = true | ) |

static inherited

Interaction with the standard C I/O objects.

Parameters

  __sync | Whether to synchronize or not.

Returns
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary

## tellg()

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits >::pos_type std::basic_istream< _CharT, _Traits >::tellg | ( | void |  | ) |

Getting the current read position.

Returns
  A file position object.

If `fail()` is not false, returns `pos_type`(-1) to indicate failure. Otherwise returns `rdbuf()->pubseekoff(0,cur,in)`.

Note
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`. At variance with putback, unget and seekg, eofbit is not cleared first.

Definition at line 868 of file istream.tcc.

References std::ios_base::badbit, std::ios_base::cur, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::in, and std::basic_ios< _CharT, _Traits >::rdbuf().

## tie() [1/2]

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::tie | ( |  | ) | const

inline inherited

Fetches the current tied stream.

Returns
  A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, `std::cin` is tied to `std::cout`.

Definition at line 295 of file basic_ios.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry(), and copyfmt().

## tie() [2/2]

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::tie | ( | basic_ostream< _CharT, _Traits > * | __tiestr | ) |

inline inherited

Ties this stream to an output stream.

Parameters

  __tiestr | The output stream.

Returns
  The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 307 of file basic_ios.h.

## unget()

template<typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::unget | ( | void |  | ) |

Unextracting the previous character.

Returns
  *this

If `rdbuf()` is not null, calls `rdbuf()->sungetc(c)`.

If `rdbuf()` is null or if `sungetc()` fails, sets badbit in the error state.

Note
  This function first clears eofbit. Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 797 of file istream.tcc.

References _M_gcount, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::rdstate().

Referenced by std::__detail::operator>>().

## unsetf()

void std::ios_base::unsetf | ( | fmtflags | __mask | ) |

inline inherited

Clearing format flags.

Parameters

  __mask | The flags to unset.

This function clears __mask in the format flags.

Definition at line 721 of file ios_base.h.

References fmtflags.

## widen()

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::widen | ( | char | __c | ) | const

inline inherited

Widens characters.

Parameters

  __c | The character to widen.

Returns
  The widened character.

Maps a character of `char` to a character of `char_type`.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).widen(c)
std::basic_ios::widen
char_type widen(char __c) const
Widens characters.
Definition basic_ios.h:449

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 449 of file basic_ios.h.

Referenced by std::endl(), std::basic_ios< char_type, traits_type >::fill(), std::basic_istream< char_type, traits_type >::get(), std::basic_istream< char_type, traits_type >::get(), std::basic_istream< char_type, traits_type >::getline(), std::getline(), std::getline(), std::operator<<(), std::operator<<(), and std::tr2::operator>>().

## width() [1/2]

streamsize std::ios_base::width | ( |  | ) | const

inline inherited

Flags access.

Returns
  The minimum field width to generate on output operations.

Minimum field width refers to the number of characters.

Definition at line 755 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_put< _CharT, _OutIter >::do_put(), std::operator>>(), and std::operator>>().

## width() [2/2]

streamsize std::ios_base::width | ( | streamsize | __wide | ) |

inline inherited

Changing flags.

Parameters

  __wide | The new width value.

Returns
  The previous value of width().

Definition at line 764 of file ios_base.h.

## xalloc()

int std::ios_base::xalloc | ( |  | ) |
throw | ( | ) |  |  |

static inherited

Access to unique indices.

Returns
  An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

## Friends And Related Symbol Documentation

## sentry

template<typename _CharT, typename _Traits>

friend class sentry

friend

Definition at line 110 of file istream.

## Member Data Documentation

## __noreplace

const openmode std::ios_base::__noreplace

static inherited

Definition at line 474 of file ios_base.h.

## _M_callbacks

_Callback_list* std::ios_base::_M_callbacks

protected inherited

Definition at line 596 of file ios_base.h.

## _M_ctype

template<typename _CharT, typename _Traits>

const __ctype_type* std::basic_ios< _CharT, _Traits >::_M_ctype

protected inherited

Definition at line 102 of file basic_ios.h.

## _M_exception

iostate std::ios_base::_M_exception

protected inherited

Definition at line 561 of file ios_base.h.

## _M_fill

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::_M_fill

mutable protected inherited

Definition at line 97 of file basic_ios.h.

## _M_fill_init

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::_M_fill_init

mutable protected inherited

Definition at line 98 of file basic_ios.h.

## _M_flags

fmtflags std::ios_base::_M_flags

protected inherited

Definition at line 560 of file ios_base.h.

## _M_gcount

template<typename _CharT, typename _Traits>

streamsize std::basic_istream< _CharT, _Traits >::_M_gcount

protected

The number of characters extracted in the previous unformatted function; see gcount().

Definition at line 84 of file istream.

Referenced by get(), get(), get(), get(), ignore(), ignore(), peek(), putback(), read(), readsome(), and unget().

## _M_ios_locale

locale std::ios_base::_M_ios_locale

protected inherited

Definition at line 628 of file ios_base.h.

## _M_local_word

_Words std::ios_base::_M_local_word[_S_local_word_size]

protected inherited

Definition at line 618 of file ios_base.h.

## _M_num_get

template<typename _CharT, typename _Traits>

const __num_get_type* std::basic_ios< _CharT, _Traits >::_M_num_get

protected inherited

Definition at line 106 of file basic_ios.h.

## _M_num_put

template<typename _CharT, typename _Traits>

const __num_put_type* std::basic_ios< _CharT, _Traits >::_M_num_put

protected inherited

Definition at line 104 of file basic_ios.h.

## _M_precision

streamsize std::ios_base::_M_precision

protected inherited

Definition at line 558 of file ios_base.h.

## _M_streambuf

template<typename _CharT, typename _Traits>

basic_streambuf<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::_M_streambuf

protected inherited

Definition at line 99 of file basic_ios.h.

## _M_streambuf_state

iostate std::ios_base::_M_streambuf_state

protected inherited

Definition at line 562 of file ios_base.h.

## _M_tie

template<typename _CharT, typename _Traits>

basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::_M_tie

protected inherited

Definition at line 96 of file basic_ios.h.

## _M_width

streamsize std::ios_base::_M_width

protected inherited

Definition at line 559 of file ios_base.h.

## _M_word

_Words* std::ios_base::_M_word

protected inherited

Definition at line 622 of file ios_base.h.

## _M_word_size

int std::ios_base::_M_word_size

protected inherited

Definition at line 621 of file ios_base.h.

## _M_word_zero

_Words std::ios_base::_M_word_zero

protected inherited

Definition at line 613 of file ios_base.h.

## adjustfield

const fmtflags std::ios_base::adjustfield

static inherited

A mask of left|right|internal. Useful for the 2-arg form of `setf`.

Definition at line 401 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::internal(), std::left(), and std::right().

## app

const openmode std::ios_base::app

static inherited

Seek to end before each write.

Definition at line 455 of file ios_base.h.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::overflow(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## ate

const openmode std::ios_base::ate

static inherited

Open and seek to end immediately after opening.

Definition at line 458 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open().

## badbit

const iostate std::ios_base::badbit

static inherited

Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).

Definition at line 425 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_istream< char_type, traits_type >::sentry::sentry(), std::basic_ostream< _CharT, _Traits >::sentry::~sentry(), std::basic_ios< _CharT, _Traits >::clear(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_iostream< char_type, traits_type >::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_iostream< char_type, traits_type >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_istream< _CharT, char_traits< _CharT > >::tellg(), and std::ws().

## basefield

const fmtflags std::ios_base::basefield

static inherited

A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.

Definition at line 404 of file ios_base.h.

Referenced by std::dec(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::hex(), and std::oct().

## beg

const seekdir std::ios_base::beg

static inherited

Request a seek relative to the beginning of the stream.

Definition at line 495 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::seekpos().

## binary

const openmode std::ios_base::binary

static inherited

Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary.

Definition at line 463 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::showmanyc().

## boolalpha

const fmtflags std::ios_base::boolalpha

static inherited

Insert/extract `bool` in alphabetic rather than numeric format.

Definition at line 349 of file ios_base.h.

Referenced by std::boolalpha(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::noboolalpha().

## cur

const seekdir std::ios_base::cur

static inherited

Request a seek relative to the current position within the sequence.

Definition at line 498 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

## dec

const fmtflags std::ios_base::dec

static inherited

Converts integer input or generates integer output in decimal base.

Definition at line 352 of file ios_base.h.

Referenced by std::dec().

## end

const seekdir std::ios_base::end

static inherited

Request a seek relative to the current end of the sequence.

Definition at line 501 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

## eofbit

const iostate std::ios_base::eofbit

static inherited

Indicates that an input operation reached the end of an input sequence.

Definition at line 428 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_iostream< char_type, traits_type >::get(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, char_traits< _CharT > >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, char_traits< _CharT > >::seekg(), std::basic_istream< _CharT, char_traits< _CharT > >::sync(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## failbit

const iostate std::ios_base::failbit

static inherited

Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.

Definition at line 433 of file ios_base.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry(), std::basic_fstream< char >::close(), std::basic_ifstream< char >::close(), std::basic_ofstream< char >::close(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::operator<<(), std::basic_iostream< char_type, traits_type >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), and std::basic_ostream< _CharT, _Traits >::seekp().

## fixed

const fmtflags std::ios_base::fixed

static inherited

Generate floating-point output in fixed-point notation.

Definition at line 355 of file ios_base.h.

Referenced by std::fixed(), and std::hexfloat().

## floatfield

const fmtflags std::ios_base::floatfield

static inherited

A mask of scientific|fixed. Useful for the 2-arg form of `setf`.

Definition at line 407 of file ios_base.h.

Referenced by std::defaultfloat(), std::fixed(), std::hexfloat(), and std::scientific().

## goodbit

const iostate std::ios_base::goodbit

static inherited

Indicates all is well.

Definition at line 436 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_iostream< char_type, traits_type >::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_iostream< char_type, traits_type >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, char_traits< _CharT > >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, char_traits< _CharT > >::seekg(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## hex

const fmtflags std::ios_base::hex

static inherited

Converts integer input or generates integer output in hexadecimal base.

Definition at line 358 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::hex().

## in

const openmode std::ios_base::in

static inherited

Open for input. Default for `ifstream` and fstream.

Definition at line 466 of file ios_base.h.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_stringbuf< char >::basic_stringbuf(), std::basic_stringstream< char >::basic_stringstream(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_streambuf< char_type, traits_type >::pubseekoff(), std::basic_streambuf< char_type, traits_type >::pubseekpos(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_streambuf< char_type, traits_type >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< char >::seekoff(), std::basic_streambuf< char_type, traits_type >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::seekpos(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## internal

const fmtflags std::ios_base::internal

static inherited

Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated.

Definition at line 363 of file ios_base.h.

Referenced by std::internal().

## left

const fmtflags std::ios_base::left

static inherited

Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.).

Definition at line 367 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), and std::left().

## oct

const fmtflags std::ios_base::oct

static inherited

Converts integer input or generates integer output in octal base.

Definition at line 370 of file ios_base.h.

Referenced by std::oct().

## out

const openmode std::ios_base::out

static inherited

Open for output. Default for `ofstream` and fstream.

Definition at line 469 of file ios_base.h.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_stringbuf< char >::basic_stringbuf(), std::basic_stringstream< char >::basic_stringstream(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::pubseekoff(), std::basic_streambuf< char_type, traits_type >::pubseekpos(), std::basic_streambuf< char_type, traits_type >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< char >::seekoff(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_streambuf< char_type, traits_type >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::seekpos(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## right

const fmtflags std::ios_base::right

static inherited

Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.).

Definition at line 374 of file ios_base.h.

Referenced by std::right().

## scientific

const fmtflags std::ios_base::scientific

static inherited

Generates floating-point output in scientific notation.

Definition at line 377 of file ios_base.h.

Referenced by std::hexfloat(), and std::scientific().

## showbase

const fmtflags std::ios_base::showbase

static inherited

Generates a prefix indicating the numeric base of generated integer output.

Definition at line 381 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::noshowbase(), and std::showbase().

## showpoint

const fmtflags std::ios_base::showpoint

static inherited

Generates a decimal-point character unconditionally in generated floating-point output.

Definition at line 385 of file ios_base.h.

Referenced by std::noshowpoint(), and std::showpoint().

## showpos

const fmtflags std::ios_base::showpos

static inherited

Generates a + sign in non-negative generated numeric output.

Definition at line 388 of file ios_base.h.

Referenced by std::noshowpos(), and std::showpos().

## skipws

const fmtflags std::ios_base::skipws

static inherited

Skips leading white space before certain input operations.

Definition at line 391 of file ios_base.h.

Referenced by std::noskipws(), std::__detail::operator>>(), and std::skipws().

## trunc

const openmode std::ios_base::trunc

static inherited

Truncate an existing stream when opening. Default for `ofstream`.

Definition at line 472 of file ios_base.h.

## unitbuf

const fmtflags std::ios_base::unitbuf

static inherited

Flushes output after each output operation.

Definition at line 394 of file ios_base.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::~sentry(), std::nounitbuf(), and std::unitbuf().

## uppercase

const fmtflags std::ios_base::uppercase

static inherited

Replaces certain lowercase letters with their uppercase equivalents in generated output.

Definition at line 398 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::nouppercase(), and std::uppercase().

The documentation for this class was generated from the following files:

- iosfwd
- istream
- istream.tcc